
; ----- Defines

	_v0 = ($80 + ( 2 * 4))
	_v1 = ($80 + ( 3 * 4))
	_a0 = ($80 + ( 4 * 4))
	_a1 = ($80 + ( 5 * 4))
	_a2 = ($80 + ( 6 * 4))
	_a3 = ($80 + ( 7 * 4))
	_ra = ($80 + (31 * 4))

; ----- Macros

	AS .macro
	sep #$20
	.as
	.endm

	AL .macro
	rep #$20
	.al
	.endm

	XS .macro
	sep #$10
	.xs
	.endm

	XL .macro
	rep #$10
	.xl
	.endm

	AXS .macro
	sep #$30
	.as
	.xs
	.endm

	AXL .macro
	rep #$30
	.al
	.xl
	.endm

; ----- Code

	.al
	.xl

	*=$1000

jump_base
	.word _tick_install, _tick_uninstall, _tick
	.word _supercpu_turbo
	.align $100

_tick_install
	php
	#AL
	pha

	sei

	stz _tick_count + 0
	stz _tick_count + 2

	#AS

	; Set MMU to RAM at $a000-$bfff and $e000-$ffff
	lda #$35
	sta $01

	; disable timer interrupts
	lda #$7f
	sta $dc0d
	sta $dd0d

	; disable VIC interrupts
	stz $d01a

	; acknowledge interrupts
	lda $dc0d
	lda $dd0d
	lda #$ff
	sta $d019

	; set NMI vector
	lda #<_tick_irq
	sta $ffea
	lda #>_tick_irq
	sta $ffeb

	; setup timer A on CIA #2 to count 1/100 seconds
	;
	; PAL  =  985248 Hz = ( 985248 / 100) - 1 = 0x267b
	; NTSC = 1022727 Hz = (1022727 / 100) - 1 = 0x27f2
	lda #$7b
	sta $dd04
	lda #$26
	sta $dd05

	; enable timer A interrupt
	lda #%10000001
	sta $dd0d

	; set timer A to run in continuous mode and start it
	lda #%10010001
	sta $dd0e

	cli

	#AL
	pla
	plp

	; return
	jmp [_ra]

_tick_uninstall
	php
	#AL
	pha

	sei

	#AS

	; disable timer interrupts
	lda #$7f
	sta $dc0d
	sta $dd0d

	; disable VIC interrupts
	stz $d01a

	; acknowledge interrupts
	lda $dc0d
	lda $dd0d
	lda #$ff
	sta $d019

	cli

	#AL
	pla
	plp

	; return
	jmp [_ra]

_tick_irq
	#AL
	pha

	inc _tick_count + 0
	bne +
	inc _tick_count + 2
+

	#AS

	; acknowledge nmi
	lda $dd0d

	#AL
	pla

	rti

_tick_count
	.word 0, 0

_tick
	php
	#AL
	pha

	sei

	lda _tick_count + 0
	sta _v0 + 0
	lda _tick_count + 2
	sta _v0 + 2

	cli

	#AL
	pla
	plp

	; return
	jmp [_ra]

_supercpu_turbo
	php
	#AL
	pha

	#AS

	sta $d07e ; ENABLE HARDWARE REGISTERS

	lda _a0 + 0
	and #$01
	beq _turbo_off

_turbo_on
	; 20 MHz SCPU mode
	sta $d07b
	; BASIC optimization
	sta $d076
	bra _turbo_done

_turbo_off
	; 1 MHz SCPU mode
	sta $d07a
	; No optimization
	sta $d077

_turbo_done
	sta $d07f ; DISABLE HARDWARE REGISTERS

	#AL
	pla
	plp

	; return
	jmp [_ra]
